(() => {
  var __create = Object.create;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
  var __commonJS = (cb, mod) => function __require() {
    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };
  var __reExport = (target, module, copyDefault, desc) => {
    if (module && typeof module === "object" || typeof module === "function") {
      for (let key of __getOwnPropNames(module))
        if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
          __defProp(target, key, { get: () => module[key], enumerable: !(desc = __getOwnPropDesc(module, key)) || desc.enumerable });
    }
    return target;
  };
  var __toESM = (module, isNodeMode) => {
    return __reExport(__markAsModule(__defProp(module != null ? __create(__getProtoOf(module)) : {}, "default", !isNodeMode && module && module.__esModule ? { get: () => module.default, enumerable: true } : { value: module, enumerable: true })), module);
  };

  // src/src/patcher.js
  var require_patcher = __commonJS({
    "src/src/patcher.js"(exports, module) {
      function monkeyPatch(name, parentObj, patches) {
        const injId = Symbol();
        const before2 = patches["before"] === void 0 ? (...args) => args : patches["before"];
        const instead2 = patches["instead"] === void 0 ? (res2, ...args) => res2(...args) : patches["instead"];
        const after2 = patches["after"] === void 0 ? (args, res2) => res2 : patches["after"];
        const handler = {
          apply: (target, thisArg, [ctx, args]) => {
            before2.apply(ctx, args);
            res = instead2(target.bind(ctx), args);
            return after2.apply(ctx, args.concat([res]));
          }
        };
        const prox = new Proxy(parentObj[name], handler);
        const orig = parentObj[name];
        parentObj[name] = function() {
          return prox(this, [arguments]);
        };
        const unpatch = () => {
          parentObj[name] = orig;
        };
        parentObj[injId] = {
          name,
          orig,
          unpatch
        };
        return unpatch;
      }
      function before(name, parentObj, func) {
        return monkeyPatch(name, parentObj, { before: func });
      }
      function instead(name, parentObj, func) {
        return monkeyPatch(name, parentObj, { instead: func });
      }
      function after(name, parentObj, func) {
        return monkeyPatch(name, parentObj, { after: func });
      }
      module.exports = {
        monkeyPatch,
        before,
        instead,
        after
      };
    }
  });

  // src/init.js
  var patcher = __toESM(require_patcher());
  async function init(obj) {
    obj.demon = {
      patcher: {
        patcher
      }
    };
  }
  var init_default = init;

  // src/index.js
  if (window.demon) {
    delete window.demon;
  }
  init_default(window);
})();
